* migstat06_spss.zip: migstat06.sps.

* IBM SPSS Statistics 20, Release 20.0.0.1 .

set length none.
set width 132.
set header no.
* Daten- bzw. Arbeitsverzeichnis in '<...>' eintragen; z. B. c:\temp .
CD '<Arbeitsverzeichnis>'.

* ============================================================================.
*                                                                             .
* SPSS-PROGRAMM ZUR TYPISIERUNG DES MIGRATIONSSTATUS IM MIKROZENSUS 2006      .
*                                                                             .
* Programmautor/en:                                                           .
* SAS-Originalprogramm: Gunter Brueckner (Statistisches Bundesamt;            .
*             Referat F 204 Migration und integration, Wohnen).               .
* Anpassungen an Scientific Use File Mikrozensus 2006: Delia Jaeger,          .
*             Bernhard Schimpl-Neimanns (GESIS, GML)                          .
*                                                                             .
* Programmzweck:                                                              .
*   Dieses Programm dient der Replikation des Migrationsstatus, Variable MIG, .
*   und der Staatsangehoerigkeit zum Migrationsstatus (MIGS) im Scientific    .
*   Use File (SUF) des Mikrozensus 2006.                                      .
*   Die Programme basieren auf den SAS-Programmen zum Original-Mikrozensus    .
*   des Statistischen Bundesamtes und wurden an Recodierungen des SUF         .
*   angepasst.                                                                .
*   Bei der Replikation der Variablen Staatsangehoerigkeit zum                .
*   Migrationsstatus (MIGS) ist zu beachten, dass aus Gruenden des            .
*   Datenschutzes Angaben zur zweiten Staatsangehoerigkeit (EF370) nur        .
*   rudimentaer vorhanden sind.                                               .
*   Des Weiteren sind die zur Konstruktion von MIGS verwendeten Variablen     .
*       EF369 1. Staatsangehoerigkeit                                         .
*   und EF374 Staatsangehoerigkeit: vor Einbuergerung                         .
*   unterschiedlich codiert. Die Replikation ist deshalb nur eingeschraenkt   .
*   moeglich.                                                                 .
*                                                                             .
* Weiterfuehrende Programmbeschreibung:                                       .
*   Jaeger, Delia und Bernhard Schimpl-Neimanns: Typisierung des              .
*   Migrationshintergrundes in den Mikrozensus Scientific-Use-Files 2005-2009 .
*   GESIS-Technical Report Nr. 2012/08. Mannheim: GESIS. URL:                 .
*      http://www.gesis.org/fileadmin/upload/forschung/publikationen/         .
*      gesis_reihen/gesis_methodenberichte/2012/TechnicalReport_2012-08.pdf   .
*                                                                             .
* Download dieser Datei:                                                      .
*   http://www.gesis.org/missy/studie/klassifikationen/                       .
*   konzepte-und-definitionen/migrationshintergrund/migstat06_spss.zip        .
*                                                                             .

* Siehe auch Anhang 1: Personen mit Migrationshintergrund - Auf dem Weg zu    .
*   einer definitorischen Abgrenzung - S. 398-407 in: Statistisches Bundesamt,.
*   2011: Bevoelkerung mit Migrationshintergrund. Ergebnisse des Mikrozensus  .
*   2009. Fachserie 1 Reihe 2.2. Wiesbaden. URL:                              .
*   https://www.destatis.de/DE/Publikationen/Thematisch/Bevoelkerung/         .
*   MigrationIntegration/Migrationshintergrund2010220097004.pdf?__blob=       .
*   publicationFile; letzter Zugriff: 24.07.2012                              .
*                                                                             .
* Programmstruktur:                                                           .
* 0. Datenvorbereitung: ID_2006.sps, migstat06.sps                            .
* 1. Grundtypisierung des Migationshintergrundes                              .
* 2. Identifikation von 3-Generationen-Haushalten                             .
* 3. Endtypisierung der Grosseltern                                           .
* 4. Endtypisierung der Eltern                                                .
* 5. Endtypisierung Befragte                                                  .
* 6. Umsetzung von Zeitreihenkompatibilitaet (entfaellt im MZ 2006)           .
* 7. Variablendefinition fuer SUF- und Fachserien-Ergebnisse                  .
*                                                                             .
* Programmstatus:                                                             .
* Getestet mit SPSS Statistics 20 for Windows und dem Scientific Use File     .
* Mikrozensus 2006, Version 1 vom 19.02.2009                                  .
* Stand: Juli 2012                                                            .
* ============================================================================.


* SUF MZ 2006 Variablenauswahl.
* Lokalen Dateinamen mit Verzeichnis in <> entragen.  
get file = '<mz2006.sav>' 
    /keep EF1   EF3   EF4   EF5a  EF5b  EF12  EF30  EF31  EF37  EF44  EF46 
          EF47  EF49  EF50  EF51  EF52  EF53  EF54  EF55 
          EF366 EF367 EF368 EF369 EF370 EF371 EF372 EF373 EF374 EF663 EF952.


* ====================================================================.
* 0. DATENVORBEREITUNG .

* Revision der Haushaltsnummern.
* siehe http://www.gesis.org/missy/fileadmin/missy/daten/mikrodaten_tools/Rekodierung_doppelter_Identifikatoren/ID_2006.sps .
* Kopie der Originalvariablen  .
*   EF4   => EF4_ORG           .
*   EF5a  => EF5a_ORG          .
* Ersatz durch neue Variablen  .
*   EF4R  => EF4               .
*   EF5aR => EF5a              .
* ABGRENZUNG FUER HH-AUSWERTUNGEN EF1 EF3 EF4 [+ PERSON: EF5a] .
* - EF5b und EF12 NICHT VERWENDEN - .
* Ausgangsdaten: Scientific Use File Mikrozensus 2006: mz2006.sav . 
*    Variablenauswahl: Zur Abgrenzung eines Haushalts und Variablen fuer .
*       Erstellung des Migrationsstatus erforderliche Variablen .
* Ergebnis: Datei mit revidierter Haushalts- (EF4R) und Personennummer (EF5R): mz2006r.sav. 
* Falls bereits korrigierte Daten vorliegen, kann das Kommando deaktiviert werden. 
include file = 'ID_2006.sps'.

* Arbeitsvariablen loeschen.
delete variables hhnr1 id1 hhnr.

sort cases by ID_ORG.

* Sichern der Variablenauswahl mit revidierten Haushaltsnummern und .
*         Satznummer der Ausgangsdaten ID_ORG.
save outfile='mz2006r.sav' 
    /keep EF1 EF3 EF4 EF5a EF5b EF12 EF30 EF31 EF37 EF44 EF46 
          EF47 EF49 EF50 EF51 EF52 EF53 EF54 EF55 
          EF366 EF367 EF368 EF369 EF370 EF371 EF372 EF373 EF374 EF663 EF952 
          EF4_ORG  EF5a_ORG ID_ORG.
missing values all ().
execute.


* Neue Haushaltsnr. bilden, um extra Programme fuer Jahresbestand .
*      (EF5b=0) und Jahresueberhang (EF5b=1) zu vermeiden.
* ===> ohne Beruecksichtigung Jahresueberhang (EF5b) und Berichtsquartal (EF12) .
compute V4 = EF4.
var label V4 'HHNR EF4 korrigiert'.
formats V4 (f4.0).

* Neue PERS.Nr.
compute V5 = EF5a.
var label V5 'PERS.NR im HH (ex EF5a)'.
formats V5 (f2.0).


* ---------------------------------------------------------------------------.
* Harmonisierung der Staatsangehoerigkeiten                                  .
* ZU BEACHTEN: Aufgrund unterschiedlicher Codierungen bei der Anonymisierung .
*              des Scientific Use Files bei den Variablen EF369 und EF374    .
*              sowie im Vergleich zu den Originaldaten kann die Staatsange-  .
*              hoerigkeit zum Migrationsstatus (SA_erw, MIGS) nicht bzw. nur .
*              naeherungsweise repliziert werden.                            .
* EF369 1. Staatsangehoerigkeit   | EF374 Staatsangehoerigk.: vor Einbuerg.  .
*    1 = 01,07,11,15,17-19,31,37  |    1 = 1,18                              .
*    3 = 03,25                    |                                          .
*    4 = 04,08,27                 |    4 = 04,08,11,27                       .
*                                 |    7 = 07,15                             .
*                                 |   10 = 10,37                             .
*   12 = 12,16,20,28,39           |   12 = 12,16,20,28,39                    .
*                                 |   24 = 24,32                             .
*   30 = 30,33                    |                                          .
*   43 = 43,44                    |   43 = 43,44                             .
*   45 = 45,46                    |                                          .
*   52 = 52,54                    |                                          .
*   55 = 55,98                    |   55 = 55,98                             .
* ---------------------------------------------------------------------------.
* Originalvariablen sichern.
rename variables (EF369 EF374 = EF369ORG EF374ORG).
execute.

* Harmonisierte Recodierung.
recode EF369ORG (32=24) (else=copy) into EF369.
recode EF374ORG (4 10 19 7 17 31=1) (25=3) (33=30) (46=45) 
                (54=52) (else=copy) into EF374.
var label EF369 'F98a 1. Staatsangehoerigkeit (EF369_ORG recodiert)'.
var label EF374	'F100b Staatsangehoerigk.: vor Einbuergerung (EF374_ORG recodiert)'.
formats EF369 EF374 (F2.0).
Value Label EF369 EF374
    0 'Entfaellt (Deutsche ohne weitere Staatsangehoerigkeit)'
    1 'EU-25: Belgien(01), Luxemburg(18), Irland(11), Zypern(37), Malta(19); Sonst. Europa: Estland(07), Lettland(15), Litauen(17), Slowenien(31)'
    2 'Sonst. Europa: Bosnien und Herzegowina(02)'
    3 'Sonst. Europa: Bulgarien(03), Rumaenien(25)'
    4 'EU-25: Daenemark(04), Finnland(08), Schweden(27)'
    5 'Sonst. Europa: Ehemalige Sowjetunion(05)'
    6 'Sonst. Europa: Ehemaliges Jugoslawien(06)'
    9 'EU-25: Frankreich(09)'
   10 'EU-25: Griechenland(10)'
   12 'Sonst. Europa: Island(12), Liechtenstein(16), Norwegen(20), Schweiz(28), Sonstiges Europa(39)'
   13 'EU-25: Italien(13)'
   14 'Sonst. Europa: Kroatien(14)'
   21 'EU-25: Niederlande(21)'
   22 'EU-25: Oesterreich(22)'
   23 'Sonst. Europa: Polen(23)'
   24 'EU-25: Portugal(24), Spanien(32)'
   26 'Sonst. Europa: Russische Foederation(26)'
   29 'Sonst. Europa: Serbien und Montenegro(29)'
   30 'Sonst. Europa: Slowakei(30), Tschechische Republik(33)'
   34 'Sonst. Europa: Tuerkei(34)'
   35 'Sonst. Europa: Ungarn(35)'
   36 'EU-25: Vereinigtes Koenigreich(36)'
   38 'Sonst. Europa: Sonstiges Osteuropa(38)'
   40 'Afrika: Marokko(40)'
   41 'Afrika: Sonstiges Nordafrika(41)'
   42 'Afrika: Sonstiges Afrika(42)'
   43 'Amerika: Vereinigte Staaten(43), Sonstiges Nordamerika(43)'
   45 'Amerika: Mittelamerika und Karibik(45), Suedamerika(46)'
   47 'Naher und Mittlerer Osten: Irak(47)'
   48 'Naher und Mittlerer Osten: Iran(48)'
   49 'Sonstiger Naher und Mittlerer Osten(49)'
   50 'Sued- und Suedostasien: Vietnam(50)'
   51 'Sued- und Suedostasien: Afghanistan(51)'
   52 'Sonstiges Sued- und Suedostasien(52), Sonstiges Ostasien(54)'
   53 'Ostasien: China(53)'
   55 'Uerige Welt(55), Staatenlos(98)'
   56 'Sonst. Europa: Ukraine(56)'
   57 'Naher und Mittlerer Osten: Kasachstan(57)'
   99 'Ohne Angabe'. /* 99 fuer MIGS bzw. SA_erw */

* Weil Variable EF370 2. Staatsangehorrigkeit im SUF nur die .
* Information 0 Entfaellt (Deutsche, Auslaender mit nur einer Staatsangeh.
*      und    1 vorhanden .
* enthaelt, wird unten bei .
*   * SA*: Staatsangehoerigkeit .
*   * nur deutsche SA .
*     (...) .
*   * nur auslaendische SAs .
*   else.
*      compute Ausl=1.
*      (...) .
* die Zuweisung: .
*    if (EF370<>0) SA2=EF370.
* mit Kommentaren versehen und ist somit inaktiv.
* Andernfalls wuerde die Zuweisung des Codes 1 in den nachfolgenden .
* Typisierungen faelschlicherweise als Staatsangehoerigkeit "Belgien" .
* interpretiert.
* ---------------------------------------------------------------------------.


sort cases by EF1  /* Bundesland */
              EF3  /* Auswahlbezirk */
              V4   /* fortlfd. HH-Nr. korrigiert, ohne Jahresueberhang, ohne Berichtsquartal */
              V5.  /* neue Pers.nr. im HH */
execute.

* ====================================================================.
* 1. Grundtypisierung des Migrationshintergrundes                     .
*                                                                     .
*    Es werden zunaechst nur die Angaben der Person selbst zur        .
*    Typisierung verwendet. Die erste Typisierung erfolgt nach        .
*    Angaben zur Staatsangehoerigkeit (deutsch / nicht-deutsch) und   .
*    Geburtsland (Ausland / Inland).                                  .

compute Gebj=EF47.
var label Gebj 'Geburtsjahr (EF47)'.
formats Gebj (f4.0).

compute BRDBorn=EF366.
var label BRDBorn 'Geburtsland: BRD (EF366)'.
formats BRDBorn (f1.0).
val label BRDBorn 1 'Ja, hier geboren' 
                  8 'Nein, zugezogen' 
                  9 'ohne Angabe'.

recode BRDBorn (1=0) (8=1) (9=9) (else=9) into Zuzug.
var label Zuzug 'Zuzug ex BRDBorn, EF366'.
formats Zuzug (f1.0).
value label Zuzug 0 'kein Zuzug' 
                  1 'foreign born' 
                  2 'Zuzug nach 6+ Mo im Ausland:= in D geboren' 
                  9 'k.A.'.

compute JZuzug=EF367.
if (EF367=1949) JZuzug=1949. /* Zuzug vor 1950 */
if (EF367=9999) JZuzug=9.    /* o.A. zum Zuzugsjahr */
if (EF367=0)    JZuzug=0.    /* kein Zuzugsjahr sinnvoll */
var lab JZuzug 'Zuzugsjahr'.
formats JZuzug (f4.0).
value label JZuzug 1949 'Zuzug vor 1950' 
                      9 'o.A. zum Zuzugsjahr'  
                      0 'kein Zuzugsjahr sinnvoll'.

if (BRDBorn=1 & JZuzug>9) Zuzug=2.
if (BRDBorn=8 & JZuzug<10) JZuzug=9.

* SA*: Staatsangehoerigkeit .
* nur deutsche SA .
do if (EF368=1).
   compute Ausl=0.
   compute SADopp=0.
   compute SA1=0.
   compute SA2=$sysmis.
* deutsche und auslaendische SA .
else if (EF368=2). 
   compute Ausl=0.
   compute SADopp=1.
   compute SA1=0.
   compute SA2=EF369.
* nur auslaendische SAs .
else.
   compute Ausl=1.
   compute SA1=EF369.
   if (EF370=0) SADopp=0.
   if (EF370=0) SA2=$sysmis.
   if (EF370<>0) SADopp=1. /* 09.01.2012: if (EF370<>0) SA2=EF370 [nur Code: 1='vorhanden'] */
end if.

var lab SA1 'Aktuelle (erste) Staatsangehoerigkeit (EF368-EF370)'.
var lab SA2 'Aktuelle (zweite) Staatsangehoerigkeit (EF368-EF370)'.
var lab SADopp 'Doppelte Staatsangehoerigkeit (EF368-EF370)'.
var lab Ausl 'Auslaendische Staatsangehoerigkeit'.
val lab Ausl SADopp 0 'nein' 1 'ja'.
formats Ausl SADopp SA1 (f1.0) SA2 (f2.0).
execute.

* Einbuergerung .
do if (EF372=1).
   compute Eingeb=1.
   recode EF373 (0=9) (else=copy) into JEinb.
   recode EF374 (0=sysmis) (else=copy) into SA3.
* Keine Einbuergerung .
else.
  compute Eingeb=0.
  compute JEinb=9.
  compute SA3=0.
end if.

var lab Eingeb 'Eingebuergert'.
var lab JEinb 'Einbuergerungsjahr'.
var lab SA3 'Staatsangeh. vor Einbuergerung/Zuzug als Spaetaussiedler'.
formats Eingeb (f1.0) JEinb (f4.0) SA3 (f2.0).
val lab Eingeb 0 'nein' 1 'ja'.
execute.

* -------------------------------------------------------------------.
* Ueberblick zu nachfolgenden Zuweisungen .
* MIG: Migrationstypus .
*      1. Stelle: Migrationstyp: .
*                 1=vertrieben .
*                 2=als Deutsche/r bzw. Spaetaussiedler zugewandert .
*                 3=eingebuergert .
*                 4=Auslaender/in .
*      2. Stelle: Generation: .
*                 1=im Ausland geboren .
*                 2=in Deutschland geboren .
* Vorlaeufige Codes MIG .
* 11=Vertriebene vor 1950 .
* 21=Deutsche Zuwanderer .
* 29=als Deutsche/r zugewandert o.A. zum Zuzugsjahr (21 gleichgestellt).
* 31=zugewanderter eingebuergerter Auslaender.
* 32=nicht zugewanderter eingebuergerter Auslaender.
* 41=zugewanderter Auslaender .
* 42=nicht zugewanderter Auslaender .
* 77=uneindeutig ob deutsch, vertrieben oder als Deutsche/r zugewandert .
* 99=fehlende/unvollstaendige Angaben .
* ----- .
* SA_erw: Erweiterte aktuelle Staatsangehoerigkeit .
*         [Basis fuer MIGS Staatsangehoerigkeit: Migrationsstatus] .
*         gewonnen aus SA1 - SA3 nach folgenden Regeln: .
* SA_erw = 0 = deutsch (bei MIG=0, 11).
*        = SA1 (bei Mig=41,42) .
*        = SA3 (bei Mig=31,32 und SA3<>.). 
*        = SA2 (bei MIG=21,29 oder MIG=31,32 und SA3=.) .
*        = 99  (bei MIG=21,29 und SA2=. oder MIG=31,32 und SA3=. 
*               oder bei MIG=77,99) .
* -------------------------------------------------------------------.

* A) im Ausland geboren.
* A1) als Ausl zugewandert. 
do if (BRDBorn=8 & Ausl=1).
       compute MIG=41.
       compute SA=SA1.
       compute SA_erw=SA1.
* A2) Eingebuergerte/r, im Ausland geboren .
*     SA_erw: SA vor Einbuergerung .
*             wenn fehlt, 2. SA (Doppelstaatler) .
*             ansonsten 'missing' .
else if (BRDBorn=8 & Eingeb=1).
       compute MIG=31.
       compute SA=SA1.
       compute SA_erw=SA3.
       if (sysmis(SA_erw)) SA_erw=SA2.
       if (sysmis(SA_erw)) SA_erw=99.
* A3) Vertriebener vor 1950 .
else if (BRDBorn=8 & Eingeb=0 & JZuzug=1949).
       compute MIG=11.
       compute SA=SA1.
       compute SA_erw=SA1.
* A4) Als Deutsche zugewandert .
else if (BRDBorn=8 & Eingeb=0 & JZuzug>1949).
       compute MIG=21.
       compute SA=SA1.
       compute SA_erw=SA1.
       if not (sysmis(SA2)) SA_erw=SA2.
* ... Zuzugsjahr missing: Zuzug ohne Angabe zum Jahr d.h. kann .
*                         Vertriebener oder Spaetaussiedler sein.
* Annahme 1: wenn nach 1949 geboren, dann als Spaetaussiedler 
*            zugewandert.
else if (BRDBorn=8 & Eingeb=0 & JZuzug=9 & Gebj>1949).
       compute MIG=21.
       compute SA=SA1.
       compute SA_erw=SA1.
       if not (sysmis(SA2)) SA_erw=SA2.
* Annahme 2: Wenn vor 1949 geboren und keine auslaendaendische SA, .
*            dann Vertriebener .
else if (BRDBorn=8 & Eingeb=0 & JZuzug=9 & Gebj<=1949 & SADopp=0 & SA1=0).
       compute MIG=11.
       compute SA=SA1.
       compute SA_erw=SA1.
* Annahme 3: sonst Zuzug als Spaetaussiedler ohne Datumsangabe: 29 .
else if (BRDBorn=8 & Eingeb=0 & JZuzug=9 & Gebj<=1949 & SADopp=1 & SA1=0).
       compute MIG=29.
       compute SA=SA1.
       compute SA_erw=SA1.
       if not (sysmis(SA2)) SA_erw=SA2.
* ... Jahrzuzug = 0 .
* Annahme 1.
else if (BRDBorn=8 & Eingeb=0 & JZuzug=0 & Gebj>1949).
       compute MIG=21.
       compute SA=SA1.
       compute SA_erw=SA1.
       if not (sysmis(SA2)) SA_erw=SA2.
* Annahme 2.
else if (BRDBorn=8 & Eingeb=0 & JZuzug=0 & Gebj<=1949 & SADopp=0 & SA1=0).
       compute MIG=11.
       compute SA=SA1.
       compute SA_erw=SA1.
* Annahme 3.
else if (BRDBorn=8 & Eingeb=0 & JZuzug=0 & Gebj<=1949 & SADopp=1 & SA1=0).
       compute MIG=29.
       compute SA=SA1.
       compute SA_erw=SA1.
       if not (sysmis(SA2)) SA_erw=SA2.
* B) im Inland geboren: .
* B1) als Auslaender in D geboren .
else if (BRDBorn=1 & Ausl=1).
       compute MIG=42.
       compute SA=SA1.
       compute SA_erw=SA1.
* B2) Eingebuergerte/r, in Deutschland geboren  .
else if (BRDBorn=1 & Eingeb=1).
       compute MIG=32.
       compute SA=SA1. 
       compute SA_erw=SA3.
       if (sysmis(SA_erw)) SA_erw=SA2.
       if (sysmis(SA_erw)) SA_erw=99.
* B3) in Deutschland geborener Deutscher .
else if (BRDBorn=1 & Ausl=0 & Eingeb=0).
       compute MIG=77.
       compute SA=SA1. 
       if not (sysmis(SA3)) SA_erw=SA3.
*   BRDBorn=9: keine Auskunft; kommt wohl nicht vor .
else if (BRDBorn=9).
       compute Mig=99.
       compute SA=SA1.
       if not (sysmis(SA3)) SA_erw=SA3.
end if.

formats BRDBorn Zuzug Ausl SADopp Eingeb (f1.0).
formats SA SA1 SA2 SA3 SA_erw  MIG (f2.0).
formats Gebj  JZuzug JEinb (f4.0).
var lab SA 'Aktuelle Staatsangehoerigkeit'. 
var lab SA_erw 'Erweiterte aktuelle Staatsangehoerigkeit'.
var lab MIG 'Migrationsstatus'.
recode MIG (sysmis=0).
val label MIG 
    0 'SYSMIS'
   11 'Vertriebene vor 1950'
   21 'Deutsche Zuwanderer oder (Spaet-)Aussiedler (ohne Einbuergerung)'
   22 'Ehegatte oder Kind eines (Spaet-)Aussiedlers (mit/ohne Einbuergerung)'
   25 '(Spaet-)Aussiedler (mit Einbuergerung)'
   29 '(Spaet-)Aussiedler (mit/ohne Einbuergerung) o.A. zum Zuzugsjahr'
   31 'zugewanderte/r eingebuergerte/r Auslaender/in'
   32 'nicht zugewanderte/r eingebuergerte/r Auslaender/in'
   41 'zugewanderte/r Auslaender/in'
   42 'nicht zugewanderte/r Auslaender/in'
   77 'uneindeutig ob deutsch, vertrieben oder Spaetaussiedler'
   99 'fehlende/unvollstaendige Angaben'.
execute.


* -------------------------------------------------------.
* 2006 keine Plausibilisierung zum Spaetaussiedlerstatus .
* -------------------------------------------------------.


compute MIG2 = MIG.
formats MIG2 (f2.0).
var label MIG2   'Migrationsstatus nach Grundtypisierung'.
val label MIG2
  11 'Vertriebene vor 1950'
  21 'Deutsche Zuwanderer o. (Spaet-)Aussiedler (ohne Einbuergerung)'
  29 '(Spaet-)Aussiedler (mit/ohne Einbuergerung) o.A. zum Zuzugsjahr'
  31 'zugewanderte/r eingebuergerte/r Auslaender/in'
  32 'nicht zugewanderte/r eingebuergerte/r Auslaender/in'
  41 'zugewanderte/r Auslaender/in'
  42 'nicht zugewanderte/r Auslaender/in'
  77 'uneindeutig ob deutsch, vertrieben oder Spaetaussiedler' .

compute SA_erw2 = SA_erw.
formats SA_erw2 (f2.0).
var label SA_erw2  'Erw. akt. Staatsangeh. zum Migrationsstatus nach Grundtypisierung'.


* Zwischenspeicherung Grundtypisierung .
*   Ausgangssortierung .
sort cases by  EF1 EF3 V4 V5.
save /outfile='temp_mig1.sav'.



* ====================================================================.
* 2. Identifikation von 3-Generationen-Haushalten                     .
*    Fuer die nachfolgende Typisierung des Migrationshintergrundes    .
*    von Eltern unter Verwendung von Angaben der Grosseltern werden   .
*    in diesem Schritt 3-Generationen-Haushalte identifiziert und     .
*    Identifikatoren fuer Grossmuetter- und -vaeter gebildet.         .
* ====================================================================.

* ===== VAETER ======.
compute vnr = EF55 * (EF54=1).
formats vnr (f2.0).
var label vnr 'Personennr. des Vaters (EF55)'.

* ==> Sortierung ... vnr.
sort cases by  EF1 EF3 V4 vnr.

temporary.
select if (vnr>0).
compute V5=vnr.
aggregate outfile='temp_V1.sav'
     /break EF1 EF3 V4 V5
     /V_Kids 'Kinder des Vaters' = n.
execute.

sort cases by  EF1 EF3 V4 V5.
* Angaben des Vaters zuspielen. 
match files file=*
           /table='temp_V1.sav'
           /by EF1 EF3 V4 V5.
execute.

recode V_Kids (1 thru hi=1) into VATER.
var label VATER 'Vater lediger Kinder im HH'.
formats VATER (f1.0).

temporary.
select if (VATER=1).
save /outfile='temp_V2.sav'
     /keep  = EF1 EF3 V4 V5 
     /rename (V5 = vnr).
execute.

* Sortierung fuer Zusammenspielen VATER. 
sort cases by EF1 EF3 V4 vnr.

* Angaben des Vaters zuspielen. 
match files file=*
           /table='temp_V2.sav'
           /by EF1 EF3 V4 vnr.
execute.

* Sortierung des Ausgangsfiles wieder herstellen: .
sort cases by  EF1 EF3 V4 V5 .


* ===== MUETTER ======.
compute mnr = EF53 * (EF52=1).
formats mnr (f2.0).
var label mnr 'Personennr. der Mutter (EF53)'.

* ==> Sortierung ... mnr.
sort cases by  EF1 EF3 V4 mnr.

temporary.
select if (mnr>0).
compute V5=mnr.
aggregate outfile='temp_M1.sav'
     /break EF1 EF3 V4 V5
     /M_Kids 'Kinder der Mutter' = n.
execute.

sort cases by  EF1 EF3 V4 V5.
* Angaben der Mutter zuspielen. 
match files file=*
           /table='temp_M1.sav'
           /by EF1 EF3 V4 V5.
execute.

recode M_Kids (1 thru hi=1) into MUTTER.
var label MUTTER 'Mutter lediger Kinder im HH'.
formats MUTTER (f1.0).

temporary.
select if (MUTTER=1).
save /outfile='temp_M2.sav'
     /keep  = EF1 EF3 V4 V5 
     /rename (V5 = mnr).
execute.

* Sortierung fuer Zusammenspielen MUTTER. 
sort cases by EF1 EF3 V4 mnr.

* Angaben der Mutter zuspielen. 
match files file=*
           /table='temp_M2.sav'
           /by EF1 EF3 V4 mnr.
execute.

* Sortierung des Ausgangsfiles wieder herstellen: .
sort cases by  EF1 EF3 V4 V5 .


* Eltern (Mutter oder Vater) mit Angaben zur (Gross-)Mutter: .
*   Personennummer der Grossmutter .
compute gmnr = ( (MUTTER=1 | VATER=1) & EF52=1) * EF53.
* Eltern (Mutter oder Vater) mit Angaben zum (Gross-)Vater: 
*   Personennummer des Grossvaters .
compute gvnr = ( (MUTTER=1 | VATER=1) & EF54=1) * EF55. 

temporary.
* Eltern - Pers.Nr. der Grosseltern .
select if (MUTTER=1 | VATER=1).
aggregate outfile = 'temp_GE.sav'
         /presorted
         /break EF1 EF3 V4 
         /min_gmnr = min(gmnr)
         /max_gmnr = max(gmnr)
         /min_gvnr = min(gvnr)
         /max_gvnr = max(gvnr).
execute.

* Personennr. der Grosseltern zuspielen. 
match files file=*
           /table='temp_GE.sav'
           /by EF1 EF3 V4 .
formats gmnr gvnr min_gmnr max_gmnr min_gvnr max_gvnr (f2.0).
execute.

* Ausgangssortierung fuer Tests.
sort cases by  EF1 EF3 V4 V5 .


* Kontrolle: mehr als 1 Grossmutter(nummer) im HH? .
*            Voraussetzung fuer spaetere Verwendung von .
*            'max' gmnr gvnr ist, dass dies nicht zutrifft.
temporary.
select if (max_gmnr<>min_gmnr & min_gmnr>0).
crosstabs max_gmnr by min_gmnr.
* OK.

* Kontrolle: mehr als 1 Grossvater(nummer) im HH? .
temporary.
select if (max_gvnr<>min_gvnr & min_gvnr>0).
crosstabs max_gvnr by min_gvnr.
* OK.


* Grossvater-/mutter .
compute GMutter = (max_gmnr=V5 & max_gmnr>0).
compute GVater  = (max_gvnr=V5 & max_gvnr>0).
var label GMutter 'Grossmutter mit Kindern, Enkeln im HH'.
var label GVater  'Grossvater mit Kindern, Enkeln im HH'.
* val label GMutter GVater 1 'ja'.
formats GMutter GVater (f1.0).
execute.



* ====================================================================.
* 3. Endtypisierung der Grosseltern                                   .
*                                                                     .
*    Im MZ 2006 nicht relevant, da keine Angaben zu den nicht im      .
*    Haushalt lebenden Eltern vorhanden sind. Deshalb kann die        .
*    Grundtypisierung verwendet werden.                               .
* ====================================================================.


* ====================================================================.
* 4. Endtypisierung der Eltern                                        .
*                                                                     .
*    Fuer jede Kombination von eigenem, vaeterlichen und              .
*    muetterlichen vorlaeufigen Migrationsstatus wird der             .
*    resultierende endgueltige Migrationsstatus zugewiesen. Diese     .
*    Konversions-Prozedur wird nur fuer im Inland Geborene angewandt. .
*    Abschliessend wird die Variable erweiterte Staatsangehoerigkeit  .
*    (SA_erw) ggf. durch Informationen zum Vater bzw. zur Mutter      .
*    ergaenzt.                                                        .
* ====================================================================.

* Ausgangssortierung.
sort cases by  EF1 EF3 V4 V5.

temporary.
* Angaben zum Migrationsstatus des Grossvaters speichern.
select if (GVater=1).
save outfile = 'temp_GV.sav'
     /keep EF3 V4 V5   MIG2   SA1    SA2    SA3   SA    SA_erw  
         /rename (V5   MIG2   SA1    SA2    SA3    SA    SA_erw = 
                  gvnr MIG_GV SA1_GV SA2_GV SA3_GV SA_GV SAerw_GV).
execute.

* Sortierung fuer Zusammenspielen Eltern- mit Grossvater-Angaben.
sort cases by EF1 EF3 V4 gvnr.

* Angaben der (Gross-) Vaeter zuspielen. 
match files file=*
           /table='temp_GV.sav'
           /by EF3 V4 gvnr.
execute.
sort cases by  EF1 EF3 V4 V5.

* Angaben zum Status des Grossvaters nur falls der Grossvater .
*   der Vater ist, sonst SYSMIS.
do if (gvnr<>EF55).
 recode MIG_GV SA1_GV SA2_GV SA3_GV SA_GV SAerw_GV (else=sysmis).
end if.
formats MIG_GV SA1_GV SA2_GV SA3_GV SA_GV SAerw_GV (f2.0).
execute.

temporary.
* Angaben zum Migrationsstatus der Grossmutter speichern.
select if (GMutter=1).
save outfile = 'temp_GM.sav'
   /keep EF3 V4   V5   MIG2   SA1    SA2    SA3    SA    SA_erw  
         /rename (V5   MIG2   SA1    SA2    SA3    SA    SA_erw = 
                  gmnr MIG_GM SA1_GM SA2_GM SA3_GM SA_GM SAerw_GM).
execute.

* Sortierung fuer Zusammenspielen Eltern- mit Grossmutter-Angaben.
sort cases by EF1 EF3 V4 gmnr.

* Angaben der (Gross-) Muetter zuspielen. 
match files file=*
           /table='temp_GM.sav'
           /by EF3 V4 gmnr.
execute.
sort cases by  EF1 EF3 V4 V5.

* Angaben zum Status der Grossmutter nur falls die Grossmutter .
*   die Mutter ist, sonst SYSMIS.
do if (gmnr<>EF53).
 recode MIG_GM SA1_GM SA2_GM SA3_GM SA_GM SAerw_GM (else=sysmis).
end if.
formats MIG_GM SA1_GM SA2_GM SA3_GM SA_GM SAerw_GM (f2.0).
execute.

* -------------------------------------------------------------------------.
* Ab hier die eigentliche Endtypisierung des Migrationsstatus .
*    der Eltern mittels Konversions-Prozedur, bei der nur im Inland .
*    Geborene beruecksichtigt werden.
if not any (MIG2, 11, 21, 22, 23, 25, 29, 31, 41) KonvProc=1.
var lab KonvProc 'Konversionsprozedur: gueltige Faelle'.

* EGRE: Eltern - Grosseltern .
if ( (VATER=1  & (GVNR=EF55)) | /* Vater mit Grossvater */
     (VATER=1  & (GMNR=EF53)) | /* Vater mit Grossmutter */
     (MUTTER=1 & (GVNR=EF55)) | /* Mutter mit Grossvater */
     (MUTTER=1 & (GMNR=EF53)))  /* Mutter mit Grossmutter */
    EGRE=1.
var lab EGRE 'Eltern mit Grosseltern im Haushalt'.
formats Konvproc EGRE (f1.0).
execute.

* Typisierung Eltern-Grosseltern.
compute EGRETYP=0.
if (VATER=1  & GVNR=EF55)             EGRETYP=1.  /* Vater mit Grossvater */ 
if (VATER=1  & GMNR=EF53)             EGRETYP=2.  /* Vater mit Grossmutter */
if (VATER=1  & GVNR=EF55 & GMNR=EF53) EGRETYP=3.  /* Vater mit Grossvater und -mutter */
if (MUTTER=1 & GVNR=EF55)             EGRETYP=4.  /* Mutter mit Grossvater */
if (MUTTER=1 & GMNR=EF53)             EGRETYP=5.  /* Mutter mit Grossmutter */
if (MUTTER=1 & GVNR=EF55 & GMNR=EF53) EGRETYP=6.  /* Mutter mit Grossvater und -mutter */
var lab EGRETYP 'Eltern mit Grosseltern im Haushalt'.
val lab EGRETYP 0 'TNZ'
                1 'Vater mit Grossvater'
                2 'Vater mit Grossmutter'
                3 'Vater mit Grosseltern'
                4 'Mutter mit Grossvater'
                5 'Mutter mit Grossmutter'
                6 'Mutter mit Grosseltern'.
formats EGRETYP (f1.0).


* Vorbereitung MATCH Konversionstabelle.
* Nur im Inland geborene Eltern, die nicht Grosseltern sind (EGRETYP=1-6).
do if (KonvProc=1 & (VATER=1 | MUTTER=1)). 
   recode MIG2   (else=copy) into mig_k.   /* MIG-Status Eltern vor Konversion
   if (EGRETYP=1) migV_k = MIG_GV.  /* Vater mit Grossvater im HH
   if (EGRETYP=2) migM_k = MIG_GM.  /* Vater mit Grossmutter
   if (EGRETYP=3) migV_k = MIG_GV.  /* Vater mit Grossvater und -mutter
   if (EGRETYP=3) migM_k = MIG_GM.  /* Vater mit Grossvater und -mutter
   if (EGRETYP=4) migV_k = MIG_GV.  /* Mutter mit Grossvater
   if (EGRETYP=5) migM_k = MIG_GM.  /* Mutter mit Grossmutter
   if (EGRETYP=6) migV_k = MIG_GV.  /* Mutter mit Grossvater und -mutter
   if (EGRETYP=6) migM_k = MIG_GM.  /* Mutter mit Grossvater und -mutter
   recode migM_k migV_k (sysmis=99) (else=copy).
end if.
formats mig_k migV_k migM_k (f2.0).
execute.

* Sortierung fuer Match mit Konversionsprozedur.
sort cases by mig_k migV_k migM_k KonvProc.
* ------------------------------------------------------ .
* Datei conversion.sav enthaelt die Variablen: .
*  MIG_K  Migrationsstatus der Person (hier: Vater) (SAS: _mig_).
*  MIGV_K Migrationsstatus des Vaters (hier: Grossvater) (SAS: _migv_).
*  MIGM_K Migrationsstatus der Mutter (hier: Grossmutter) (SAS: _migm_).
*  Konvproc (Konstante: 1) Hilfsvariable fuer Match.
*  MIGNEU Migrationsstatus nach Konversion (Rekodierung).
*  KENNUNG Nr. der Konversion (Rekodierung).
*  --- Beispiele Rekodierung (conversion.sav) --- ex: conversion_2011.xls .
*  MIG_K  MIGV_K  MIGM_K MIGNEU .
*    42     32      42     43   . 
*    77     21      11     52   .
*    77     21      21     62   .
* -----------------------------.
* MIG-Codes: .
*  11 'Vertriebene vor 1950' .
*  21 'Deutsche Zuwanderer oder (Spaet-)Aussiedler (ohne .
*      Einbuergerung)' .
*  42 'Als Auslaender im heutigen Bundesgebiet geboren, entweder beide .
*      Eltern als Auslaender zugewandert oder der eine Elternteil' .
*  43 'Als Auslaender im heutigen Bundesgebiet geboren, beide Eltern .
*      im heutigen Bundesgebiet geboren'
*  32 'Als Auslaender im heutigen Bundesgebiet geboren und .
*      zwischenzeitlich eingebuergert' .
*  52 'Deutscher mit einseitigem Migrationshintergrund; Migrationsstatus
*      durchweg identifizierbar, weil mit Eltern im Haushalt'.
*  62 'Deutscher mit beidseitigem Migrationshintergrund; Migrationsstatus
*      durchweg identifizierbar, weil mit Eltern im Haushalt'.
* ---------------------------------------------------------------.
match files file = *
            table = 'conversion.sav' 
     /by mig_k migV_k migM_k KonvProc.

* Neu bilden, da ggf. durch Match ueberschrieben.
if not any (MIG2, 11, 21, 22, 23, 25, 29, 31, 41) KonvProc=1.

* Ausgangssortierung.
sort cases by  EF1 EF3 V4 V5.

* Uebernahme konvertierter MIG-Typisierung.
compute MIG3 = MIG2.
if (EGRE=1 & KonvProc=1 & not(sysmis(migneu))) MIG3 = migneu.
formats MIG3 (f2.0).


var label MIG3   'Migrationsstatus nach Endtypisierung Eltern'.
val label MIG3
    0 'SYSMIS'
   11 'Vertriebene vor 1950'
   21 'Deutsche Zuwanderer oder (Spaet-)Aussiedler (ohne Einbuergerung)'
   22 'Ehegatte oder Kind eines (Spaet-)Aussiedlers (mit/ohne Einbuergerung)'
   25 '(Spaet-)Aussiedler (mit Einbuergerung)'
   29 '(Spaet-)Aussiedler (mit/ohne Einbuergerung) o.A. zum Zuzugsjahr'
   31 'zugewanderte/r eingebuergerte/r Auslaender/in'
   32 'nicht zugewanderte/r eingebuergerte/r Auslaender/in'
   41 'zugewanderte/r Auslaender/in'
   42 'nicht zugewanderte/r Auslaender/in'
   77 'uneindeutig ob deutsch, vertrieben oder Spaetaussiedler'
   99 'fehlende/unvollstaendige Angaben'.
execute.


* SA_erw durch aussagekraeftigen Vatereintrag und Muttereintrag .
*        ergaenzen, sofern noetig und moeglich .
*    SA_erw zur Kontrolle der Rekodierung als SA_erw0 sichern.
compute SA_erw0 = SA_erw.
do if (KonvProc=1 & EGRE=1).
   if ( (SA_erw=0 | SA_erw=99) & (SAerw_GV>0 & SAerw_GV<99) ) SA_erw=SAerw_GV.
   if ( (SA_erw=0 | SA_erw=99) & (SAerw_GM>0 & SAerw_GM<99) ) SA_erw=SAerw_GM.
end if.
execute.

* Ausgangssortierung .
sort cases by  EF1 EF3 V4 V5 .

* Zwischenspeicherung Gesamtfile Grundtypisierung + Endtypisierung Eltern.
save /outfile = 'temp_mig2.sav'. 

* ====================================================================.
* 5. Endtypisierung Befragte                                          .
*                                                                     .
*    Analog zur Endtypisierung der Eltern wird der endgueltige        .
*    Migrationsstatus unter Beruecksichtigung der Kombinationen von   .
*    eigenem, vaeterlichen und muetterlichen vorlaeufigen             .
*    Migrationsstatus zugewiesen, wobei auch hier die Zuweisungen nur .
*    fuer die im Inland Geborenen zur Anwendung kommen und die        .
*    erweiterte Staatsangehoerigkeit (SA_erw) ggf. durch Angaben des  .
*    Vaters bzw. der Mutter ergaenzt wird.                            .
*    Die Variable SA_erw ist Basis der Staatsangehoerigkeit zum       .
*    Migrationsstatus (MIGS).                                         .
* ====================================================================.

sort cases by EF1 EF3 V4 V5.

* --- Eltern --- .
* Migrationsrelevante Eintraege fuer Vaeter: .
*    MIG  SA1 SA2 SA3 SA SA_erw JZuzug.
temporary.
select if (Vater=1). 
save outfile = 'temp_V.sav'
     /keep EF1 EF3 V4 V5  MIG3  SA1   SA2    SA3    SA    SA_erw   JZuzug 
             /rename (V5  MIG3  SA1   SA2    SA3    SA    SA_erw   JZuzug = 
                      vnr MIG_V SA1_V SA2_V  SA3_V  SA_V  SA_erw_V JZuzug_V).
execute.

sort cases by EF1 EF3 V4 vnr.

* Angaben der Vaeter zuspielen. 
match files file=*
           /table='temp_V.sav'
           /by EF1 EF3 V4 vnr.
execute.
sort cases by  EF1 EF3 V4 V5.

* ---------------------------------------------------------------- .
* Migrationsrelevante Eintraege fuer Muetter: .
*    MIG SA1 SA2 SA3 SA SA_erw JZuzug.
temporary.
select if (Mutter=1).
save outfile = 'temp_M.sav'
     /keep EF1 EF3 V4 V5  MIG3  SA1   SA2    SA3    SA    SA_erw    JZuzug 
             /rename (V5  MIG3  SA1   SA2    SA3    SA    SA_erw    JZuzug = 
                      mnr MIG_M SA1_M SA2_M  SA3_M  SA_M  SA_erw_M  JZuzug_M).
execute.
sort cases by EF1 EF3 V4 mnr.
* Angaben der Muetter zuspielen. 
match files file=*
           /table='temp_M.sav'
           /by EF1 EF3 V4 mnr.
execute.
sort cases by  EF1 EF3 V4 V5.

* Zwischenspeicherung .
save /outfile = 'temp_mig3.sav'. 


* ---------------------------------------------------------------- .
get file = 'temp_mig3.sav' 
   /drop mig_k migV_k migM_k Konvproc migneu kennung. 



* Konversions-Prozedur nur fuer im Inland Geborene .
if not any (MIG3, 11, 21, 22, 23, 25, 29, 31, 41) KonvProc=1.
execute.

* Vorbereitung MATCH Konversionstabelle.
do if (KonvProc=1).
*    recode MIG3   (else=copy) into mig_k.
    compute mig_k = MIG3.  /* MIG-Status Person vor Konversion
    compute migV_k = mig_v.               /* MIG-Status Vater
    compute migM_k = mig_m.               /* MIG-Status Mutter 
    recode migV_k migM_k (sysmis=99) (22 23 = 21).
end if.
formats mig_k migV_k migM_k (f2.0).
execute.

sort cases by mig_k migV_k migM_k KonvProc.
match files file = *
            table = 'conversion.sav' 
     /by mig_k migV_k migM_k KonvProc.

* Ausgangssortierung.
sort cases by  EF1 EF3 V4 V5.

* neu, da durch Match ggf. ueberschrieben.
if not any (MIG3, 11, 21, 22, 23, 25, 29, 31, 41) KonvProc=1.
execute.

* Migrationsstatus NACH Konversion zuweisen.
compute MIG4 = MIG3.
if (KonvProc=1 & not(sysmis(migneu))) MIG4 = migneu.
formats MIG4 (f2.0).
var label MIG4 'Migrationsstatus Endtypisierung Befragte'.



* SA_erw durch aussagekraeftigen Vatereintrag und Muttereintrag .
*        ergaenzen, sofern noetig und moeglich .
do if (KonvProc=1).
* Angaben zum Vater: vnr=ef55.
    if (vnr=ef55 & (SA_erw=0 | SA_erw=99) & (SA_erw_V>0 & SA_erw_V<99)) SA_erw=SA_erw_V.
* Angaben zur Mutter.
    if (mnr=ef53 & (SA_erw=0 | SA_erw=99) & (SA_erw_M>0 & SA_erw_M<99)) SA_erw=SA_erw_M.
end if.
execute.


* SUF Value Labels & Vergroeberung.
val label MIG4
   0 'Deutsch ohne Migrationshintergrund'
  11 'Bis einschliesslich 1949 als Deutscher ohne Einbuergerung ' 
   + 'auf das heutige Bundesgebiet zugewandert'
  21 '21/29: 1950 und spaeter als Deutscher ohne Einbuergerung '
   + 'auf das heutige Bundesgebiet zugewandert(Spaetaussiedler) (21) '
   + '(Spaet-)Aussiedler (mit/ohne Einbuergerung) o.A. zum Zuzugsjahr (29)'
  22 'Ehegatte oder Kind von Spaetaussiedler, zeitgleich eingereist'
  25 'Spaetaussiedler mit formaler Einbuergerung'
  29 '(Spaet-)Aussiedler (mit/ohne Einbuergerung) o.A. zum Zuzugsjahr'
  31 'Als Auslaender auf das heutige Bundesgebiet zugewandert '
   + 'und zwischenzeitlich eingebuergert'
  32 'Als Auslaender im heutigen Bundesgebiet geboren und '
   + 'zwischenzeitlich eingebuergert'
  41 'Als Auslaender auf das heutige Bundesgebiet zuwandert'
  42 'Als Auslaender im heutigen Bundesgebiet geboren, entweder '
   + 'beide Eltern als Auslaender zugewandert oder der eine Elternteil'
  43 'Als Auslaender im heutigen Bundesgebiet geboren, beide Eltern '
   + 'im heutigen Bundesgebiet geboren'
  52 'Deutscher mit einseitigem Migrationshintergrund; Migrationsstatus '
   + 'durchweg identifizierbar, weil mit Eltern im Haushalt'
  53 'Deutscher mit einseitigem Migrationshintergrund; Migrationsstatus '
   + 'durchweg identifizierbar, weil mit Eltern im Haushalt'
  54 'Deutscher mit einseitigem Migrationshintergrund; Migrationsstatus '
   + 'durchweg identifizierbar, weil mit Eltern im Haushalt'
  62 'Deutscher mit beidseitigem Migrationshintergrund; Migrationsstatus '
   + 'durchweg identifizierbar, weil mit Eltern im Haushalt'
  63 'Deutscher mit beidseitigem Migrationshintergrund; Migrationsstatus '
   + 'durchweg identifizierbar, weil mit Eltern im Haushalt'
  64 'Deutscher mit beidseitigem Migrationshintergrund; Migrationsstatus '
   + 'durchweg identifizierbar, weil mit Eltern im Haushalt'
  77 'uneindeutig ob deutsch, vertrieben oder Spaetaussiedler'.
formats mig4 (f2.0).
execute.

* 6. Umsetzung von Zeitreihenkompatibilitaet entfaellt im MZ 2006 .


* ====================================================================.
* 7. Variablendefinitionen wie im SUF und fuer Fachserien-Ergebnisse  .


* ===================== MIG ======================= .
* Recodierung / Vergroeberung wie im SUF 29=>21.
recode MIG4 (29=21) (77=0) (else=copy) into mig.
var label mig 'Migrationsstatus'.
formats mig (f2.0).
val lab mig 
    0 'Deutsch ohne Migrationshintergrund '
    + 'uneindeutig ob deutsch, vertrieben oder Spaetaussiedler (MIG4=77)'
   11 'Bis einschliesslich 1949 als Deutscher ohne Einbuergerung auf '
    + 'das heutige Bundesgebiet zugewandert'
   21 '21/29: 1950 und spaeter als Deutscher ohne Einbuergerung auf '
    + 'das heutige Bundesgebiet zugewandert(Spaetaussiedler)(21); '
    + 'Ohne Angabe des Zuzugsjahrs als Deutscher ohne Einbuergerung '
    + 'auf das heutige Bundesgebiet zuwandert(29)'
   22 'Ehegatte oder Kind von Spaetaussiedler, zeitgleich eingereist'
   25 'Spaetaussiedler mit formaler Einbuergerung'
   31 'Als Auslaender auf das heutige Bundesgebiet zugewandert und '
    + 'zwischenzeitlich eingebuergert'
   32 'Als Auslaender im heutigen Bundesgebiet geboren und '
    + 'zwischenzeitlich eingebuergert'
   41 'Als Auslaender auf das heutige Bundesgebiet zuwandert'
   42 'Als Auslaender im heutigen Bundesgebiet geboren, entweder '
    + 'beide Eltern als Auslaender zugewandert oder der eine '
    + 'Elternteil als Auslaender zugewandert, der andere als '
    + 'Auslaender im heutigen Bundesgebiet geboren'
   43 'Als Auslaender im heutigen Bundesgebiet geboren, beide Eltern '
    + 'im heutigen Bundesgebiet geboren'
   52 'Deutscher mit einseitigem Migrationshintergrund; '
    + 'Migrationsstatus durchweg identifizierbar, weil mit Eltern im '
    + 'Haushalt lebend; ein Elternteil ist Spaetaussiedler (21-29)'
   53 'Deutscher mit einseitigem Migrationshintergrund; '
    + 'Migrationsstatus durchweg identifizierbar, weil mit Eltern '
    + 'im Haushalt lebend; ein Elternteil ist Deutscher durch '
    + 'Einbuergerung (31, 32)'
   54 'Deutscher mit einseitigem Migrationshintergrund; '
    + 'Migrationsstatus durchweg identifizierbar, weil mit Eltern im '
    + 'Haushalt lebend; ein Elternteil ist Auslaender (41-43)'
   62 'Deutscher mit beidseitigem Migrationshintergrund; '
    + 'Migrationsstatus durchweg identifizierbar, weil mit Eltern im '
    + 'Haushalt lebend; mind. 1 Elternteil ist Spaetaussiedler (21-29)'
   63 'Deutscher mit beidseitigem Migrationshintergrund; '
    + 'Migrationsstatus durchweg identifizierbar, weil mit Eltern im '
    + 'Haushalt lebend; entweder beide Eltern eingebuergert oder 1 '
    + 'Elternteil eingebuergert (31, 32), der andere Auslaender (41-43)'
   64 'Deutscher mit beidseitigem Migrationshintergrund; '
    + 'Migrationsstatus durchweg identifizierbar, weil mit Eltern im '
    + 'Haushalt lebend; beide Eltern sind Auslaender (41-43), es '
    + 'handelt sich um ein ius soli-Kind (Optionsmodell)'.
execute.

* Korrektur - wie SAS und Stata: migM_k=0 := migM_k=77.
if (mig_k=77 & migV_k=31 & migM_k=0 & ef3=5776 & ef4=2 & ef5a=4) mig=53.
if (mig_k=77 & migV_k=41 & migM_k=0 & ef3=6894 & ef4=3 & ef5a=7) mig=54.
execute. 

* ===================== MIGS ======================= .
* Recodierung sa_erw => migs .
* Keine einheitliche Recodierung moeglich s.o.
recode sa_erw  (else=copy) into migs.
if (mig=0) migs=0.
var lab migs 'Staatsangehoerigkeit: Migrationsstatus'.
formats migs (f2.0).
value label migs 
    0 'Entfaellt (Deutsche ohne weitere Staatsangehoerigkeit)'
    1 'EU-25: Belgien(01), Luxemburg(18), Irland(11), Zypern(37), Malta(19); Sonst. Europa: Estland(07), Lettland(15), Litauen(17), Slowenien(31)'
    2 'Sonst. Europa: Bosnien und Herzegowina(02)'
    3 'Sonst. Europa: Bulgarien(03), Rumaenien(25)'
    4 'EU-25: Daenemark(04), Finnland(08), Schweden(27)'
    5 'Sonst. Europa: Ehemalige Sowjetunion(05)'
    6 'Sonst. Europa: Ehemaliges Jugoslawien(06)'
    9 'EU-25: Frankreich(09)'
   10 'EU-25: Griechenland(10)'
   12 'Sonst. Europa: Island(12), Liechtenstein(16), Norwegen(20), Schweiz(28), Sonstiges Europa(39)'
   13 'EU-25: Italien(13)'
   14 'Sonst. Europa: Kroatien(14)'
   21 'EU-25: Niederlande(21)'
   22 'EU-25: Oesterreich(22)'
   23 'Sonst. Europa: Polen(23)'
   24 'EU-25: Portugal(24), Spanien(32)'
   26 'Sonst. Europa: Russische Foederation(26)'
   29 'Sonst. Europa: Serbien und Montenegro(29)'
   30 'Sonst. Europa: Slowakei(30), Tschechische Republik(33)'
   34 'Sonst. Europa: Tuerkei(34)'
   35 'Sonst. Europa: Ungarn(35)'
   36 'EU-25: Vereinigtes Koenigreich(36)'
   38 'Sonst. Europa: Sonstiges Osteuropa(38)'
   40 'Afrika: Marokko(40)'
   41 'Afrika: Sonstiges Nordafrika(41)'
   42 'Afrika: Sonstiges Afrika(42)'
   43 'Amerika: Vereinigte Staaten(43), Sonstiges Nordamerika(43)'
   45 'Amerika: Mittelamerika und Karibik(45), Suedamerika(46)'
   47 'Naher und Mittlerer Osten: Irak(47)'
   48 'Naher und Mittlerer Osten: Iran(48)'
   49 'Sonstiger Naher und Mittlerer Osten(49)'
   50 'Sued- und Suedostasien: Vietnam(50)'
   51 'Sued- und Suedostasien: Afghanistan(51)'
   52 'Sonstiges Sued- und Suedostasien(52), Sonstiges Ostasien(54)'
   53 'Ostasien: China(53)'
   55 'Uebrige Welt(55), Staatenlos(98)'
   56 'Sonst. Europa: Ukraine(56)'
   57 'Naher und Mittlerer Osten: Kasachstan(57)'
   99 'Ohne Angabe'.
execute.

* ======= ENDE MIG-TYPISIERUNG ===== .


* Fallzahlen. 
temporary. 
weight off.
fre mig migs.

* Hochgerechnete Verteilungen von MIG und MIGS. 
temporary. 
* Bevoelkerung am Hauptwohnsitz. 
select if (EF30>=1 & EF30<=2). 
* Hochrechnung Jahresdurchschnitt. 
weight by EF952. 
fre mig migs.


* ====================================================================.
* MIGRATIONSSTATUS.
* Vergleich mit Tabelle 2, Fachserie 1 Bevoelkerung und Erwerbstaetigkeit, .
* Reihe 2.2, Bevoelkerung mit Migrationshintergrund. 
* Z_* := Zeilennummer in Tab. 2 .
recode mig (0 thru 99=1) (else=sysmis) into Z001. 
recode mig (0 11 77=1) (else=sysmis) into Z002. 
recode mig (21 29 31 32 41 42 43 52 53 54 62 63 64=1) (else=sysmis) into Z005.
recode mig (21 29 31 41=1) (else=sysmis) into Z034.
recode mig (41=1) (else=sysmis) into Z062.
recode mig (21 29 31=1) (else=sysmis) into Z089.
recode mig (21 29=1) (else=sysmis) into Z090.
recode mig (31=1) (else=sysmis) into Z097.
recode mig (42 43 32 52 53 54 62 63 64=1) (else=sysmis) into Z119.
recode mig (42 43=1) (else=sysmis) into Z126.
recode mig (32 52 53 54 62 63 64=1) (else=sysmis) into Z133.
recode mig (32=1) (else=sysmis) into Z134.
recode mig (52 53 54 62 63 64=1) (else=sysmis) into Z140.
recode mig (62 63 64=1) (else=sysmis) into Z141.
recode mig (52 53 54=1) (else=sysmis) into Z142.
formats Z001 to Z142 (f1.0).
var lab Z001  'Insgesamt [0-77]'.
var lab Z002  'Person ohne Migrationshintergrund [0,11,77]'.
var lab Z005  'Person mit Mig-hintergrund i.e.S. [21-64]'.
var lab Z034  'Bevoelkerung mit eigener Migrationserfahrung [21-31,41]'.
var lab Z062  '+ Auslaender mit Mig-erfahrung [41]'.
var lab Z089  '+ Deutsche mit Mig-erfahrung [21-31]'.
var lab Z090  'Deutsche mit Mig-erfahrung ohne Einbuergerung [21-29]'.
var lab Z097  'Deutsche mit Mig-erfahrung durch Einbuergerung [31]'.
var lab Z119  'Bevoelkerung ohne eigene Mig-erfahrung [32,42-64]'.
var lab Z126  '+ Auslaender ohne Mig-erfahrung[42-43]'.
var lab Z133  '+ Deutsche mit Mig-hintergrund ohne Mig-erfahrung [32,52-64]'.
var lab Z134  '  - durch Einbuergerung [32]'.
var lab Z140  '  - mit mind. 1 zugew. o. als Ausl. in D geb. Elternteil [52-64]'.
var lab Z141  '    # mit beidseitigem Mig-hintergrund [62-64]'.
var lab Z142  '    # mit einseitigem Mig-hintergrund [52-54]'.
execute.

temporary.
* Bevoelkerung am Hauptwohnsitz, Jahresdurchschnitt.
select if (EF30>=1 & EF30<=2).
weight by EF952.
descriptives variables = Z001 to Z142 /statistics sum.


* STAATSANGEHOERIGKEITEN ZUM MIGRATIONSSTATUS ========================.
* Hinweis zur Auswertung von MIGS im Vergleich zur Veroeffentlichung  .
* mit Tab. 2, Fachserie 1, Reihe 2.2:                                 .
* - Aufgrund unterschiedlicher Codierungen bei der Anonymisierung des .
*   Scientific Use Files bei den Variablen EF369 und EF374 sowie im   .
*   Vergleich zu den Originaldaten kann die Staatsangehoerigkeit zum  .
*   Migrationsstatus (MIGS, SA_erw) nicht bzw. nur naeherungsweise    .
*   repliziert werden.  
* - Deutsche Zuwanderer ohne Einbuergerung sowie in Deutschland geborene    .
*    Deutsche mit ein-/beidseitigem Migrationshintergund MIGS => 0 (deutsch).

compute MIGS_R = migs.
formats MIGS_R (f2.0).
if (mig=0 | mig=11 | (mig>=21 & mig<=29) | (mig>=61 & mig<=64) | (mig>=71 & mig<=74)) MIGS_R=0. 
* Z*: Lfd. Nr. in Tab. 2
* ohne vergroeberte Kategorien im SUF (z.B. Rumaenien/Bulgarien)
* Zu beachten: Abweichungen zur Fachserie bei Z25 o Sued- und Suedostasien, da inkl. Ostasien (54)
* Staatsangehoerigkeiten zum Migrationsstatus fuer Personen mit Mig-hintergrund i.e.S.
recode MIGS_R (0 thru 99=1) (else=sysmis) into Z05. 
recode MIGS_R (01 thru 39 56 58 59=1) (else=sysmis) into Z06.
recode MIGS_R (01 04 07 thru 11 13 15 17 18 19 21 thru 24 27 30 thru 33 35 36 37=1) (else=sysmis) into Z07.
recode MIGS_R (10=1) (else=sysmis) into Z08.
recode MIGS_R (13=1) (else=sysmis) into Z09.
recode MIGS_R (23=1) (else=sysmis) into Z10.
recode MIGS_R (02 03 05 06 12 14 16 20 25 26 28 29 34 38 39 56 58 59=1) (else=sysmis) into Z11.
recode MIGS_R (2=1) (else=sysmis) into Z12.
recode MIGS_R (14=1) (else=sysmis) into Z13.
recode MIGS_R (26=1) (else=sysmis) into Z15.
recode MIGS_R (34=1) (else=sysmis) into Z17.
recode MIGS_R (56=1) (else=sysmis) into Z18.
recode MIGS_R (40 41 42=1) (else=sysmis) into Z19.
recode MIGS_R (43 thru 46=1) (else=sysmis) into Z20.
recode MIGS_R (47 thru 54 57=1) (else=sysmis) into Z22.
recode MIGS_R (47 48 49 57=1) (else=sysmis) into Z23.
recode MIGS_R (57=1) (else=sysmis) into Z24.
* recode MIGS_R (50 51 52=1) (else=sysmis) into Z25.
recode MIGS_R (98 99 0=1) (else=sysmis) into Z26.
var lab Z05 'Insgesamt'.
var lab Z06 'Europa'.
var lab Z07 'o EU 25'.
var lab Z08 'o Griechenland'.
var lab Z09 'o Italien'.
var lab Z10 'o Polen'.
var lab Z11 'o Sonstiges Europa'.
var lab Z12 'o Bosnien und Herzegowina'.
var lab Z13 'o Kroatien'.
var lab Z15 'o Russische Foederation'.
var lab Z17 'o Tuerkei'.
var lab Z18 'o Ukraine'.
var lab Z19 'Afrika'.
var lab Z20 'Amerika'.
var lab Z22 'Asien, Australien und Ozeanien'.
var lab Z23 'o Naher und Mittlerer Osten'.
var lab Z24 'Kasachstan'.
* var lab Z25 'o Sued- und Suedostasien [inkl. Ostasien (54)]'.
var lab Z26 'Ohne Angabe bzw. unzutreffend'.
execute.

temporary.
* Staatsangehoerigkeiten zum Migrationsstatus fuer Personen mit Mig-hintergrund i.e.S. (Z005).
select if (EF30>=1 & EF30<=2 & Z005=1).
weight by EF952.
descriptives variables = Z05 to Z26   /statistics sum.


* Sortierung nach revidierten Ordnungsnummern (EF1, EF3, EF4 (=EF4R), .
*    EF5a (=EF5aR), EF5b und EF12)                                    .
* oder Satznummer in Ausgangsdaten (ID_ORG) fuer Zusammenfuehren der  .
* erstellten Variablen MIG, MIGS, MIGS_R zum Scientific Use File .
sort cases by ID_ORG. /* Alternativ: ... by EF1 EF3 EF4 EF5b EF12 EF5a  */
 
* Zwischenspeicherung mit korrigierten IDs und ggf. Variablenauswahl.
save outfile = 'mig2006.sav'.
*      /keep = EF1 EF3 EF4 EF5a EF5b EF12 EF30 EF952 ID_Org EF4_ORG  EF5a_ORG
*              mig migs MIGS_R .

* ################################################################################.
* PROGRAMMENDE .
